//
// C++ Interface:
//
// Description:
//
//
// Author: Sebastian Holtermann <sebholt@xwmw.org>, (C) 2011
//
// Copyright: See COPYING file that comes with this distribution
//
//

#ifndef __INC_desktop_items_setup_hpp__
#define __INC_desktop_items_setup_hpp__

#include <mview/dev_select_view.hpp>
#include <mview/alsa_config_view_setup.hpp>
#include <mview/settings_view_setup.hpp>
#include "tray_mixer_mdev_setup.hpp"
#include "tray_mixer_view_setup.hpp"
#include "mixer_window_setup.hpp"


/// @brief Desktop_Items_Setup
///
class Desktop_Items_Setup
{
	// Public methods
	public:

	Desktop_Items_Setup ( );


	void
	read_from_storage ( );

	void
	write_to_storage ( );


	// Public attributes
	public:

	Tray_Mixer_MDev_Setup tray_mdev;
	Tray_Mixer_View_Setup tray_view;
	Mixer_Window_Setup mixer_window;
	::MView::Dev_Select_View_Setup dev_select_view;
	::MView::Alsa_Config_View_Setup alsa_cfg_view;
	::MView::Settings_View_Setup settings_view;

	bool tray_on_close;
	bool tray_show_icon;
	bool tray_is_minimized;
};


#endif
