//
// C++ Interface:
//
// Description:
//
//
// Author: Sebastian Holtermann <sebholt@xwmw.org>, (C) 2011
//
// Copyright: See COPYING file that comes with this distribution
//
//

#ifndef __INC_dialog_alsa_config_hpp__
#define __INC_dialog_alsa_config_hpp__

#include <QDialog>
#include <QPushButton>
#include <QAbstractItemModel>

#include "alsa_config_view_setup.hpp"
#include <mwdg/alsa_config_view.hpp>


namespace MView
{


/// @brief Alsa_Config_View
///
class Alsa_Config_View :
	public QWidget
{
	Q_OBJECT

	// Public methods
	public:

	Alsa_Config_View (
		QWidget * parent = 0 );


	void
	set_view_setup (
		::MView::Alsa_Config_View_Setup * setup_n );


	// Signals
	signals:

	void
	sig_close ( );


	// Private attributes
	private:

	::MView::Alsa_Config_View_Setup * _view_setup;
	::MWdg::Alsa_Config_View _cfg_view;

	QPushButton _btn_reload;
	QPushButton _btn_close;
};


} // End of namespace

#endif
