//
// C++ Interface:
//
// Description:
//
//
// Author: Sebastian Holtermann <sebholt@xwmw.org>, (C) 2011
//
// Copyright: See COPYING file that comes with this distribution
//
//

#ifndef __INC_mv_switcher_setup_hpp__
#define __INC_mv_switcher_setup_hpp__

#include <mwdg/mixer_device_setup.hpp>
#include <mwdg/inputs_setup.hpp>
#include "mv_mixer_simple_setup.hpp"
#include "mv_mixer_ctl_setup.hpp"
#include "mv_info_setup.hpp"


namespace MView
{


class Switcher_Setup
{
	// Public methods
	public:

	Switcher_Setup ( );


	// Public attributes
	public:

	bool show_vtype_select;
	unsigned int view_type;

	/// @brief Shared by all view
	::MWdg::Mixer_Device_Setup mixer_dev;

	/// @brief Shared by all view
	::MWdg::Inputs_Setup inputs;

	::MView::MV_Mixer_Simple_Setup mv_simple;
	::MView::MV_Mixer_CTL_Setup mv_ctl;
	::MView::MV_Info_Setup mv_info;
};


} // End of namespace

#endif
