//
// C++ Interface:
//
// Description:
//
//
// Author: Sebastian Holtermann <sebholt@xwmw.org>, (C) 2011
//
// Copyright: See COPYING file that comes with this distribution
//
//

#ifndef __INC_mixer_ctl_editor_enum_hpp__
#define __INC_mixer_ctl_editor_enum_hpp__

#include <mwdg/mixer_ctl_editor.hpp>
#include <QList>


namespace MWdg
{


// Forward declaration
class Mixer_CTL_Proxies_Group;


/// @brief Mixer_CTL_Edit_Enum
///
class Mixer_CTL_Edit_Enum :
	public Mixer_CTL_Editor
{
	Q_OBJECT

	// Public methods
	public:

	Mixer_CTL_Edit_Enum (
		Mixer_CTL_Editor_Data * data_n,
		QWidget * parent_n = 0 );

	~Mixer_CTL_Edit_Enum ( );

	void
	setup_single ( );

	void
	setup_multi ( );

	Mixer_CTL_Proxies_Group *
	create_proxies_group (
		::QSnd::Mixer_CTL_Elem * elem_n );


	// Public slots
	public slots:

	void
	update_proxies_values ( );


	// Private attributes
	private:

	QList < Mixer_CTL_Proxies_Group * > _proxies_groups;
};


} // End of namespace


#endif
